/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "matrix1.pas" */


#include "p2c.h"


#define MATRIX1_G
#include "matrix1.h"


/****** signum ******/
Void signum(Xr, sigj)
realtyp Xr;
short *sigj;
{
  if (Xr >= 0)
    *sigj = 1;
  if (Xr < 0)
    *sigj = -1;
}


Void vksum(am, n, rout)
realtyp (*am)[maxm];
short n;
realtyp *rout;
{
  short i;

  *rout = 0.0;
  for (i = 0; i <= n - 1; i++)
    *rout += am[i][0];
}


/****** matrixmult ******/
Void matrixmult(am, bm, cm, n, p, m)
realtyp (*am)[maxm], (*bm)[maxm], (*cm)[maxm];
short n, p, m;
{
  /*  cm=am*bm  nxm= (nxp) * (pxm) */
  short i, j, k;

  for (i = 0; i <= n - 1; i++) {
    for (j = 0; j <= m - 1; j++) {
      cm[i][j] = 0.0;
      for (k = 0; k <= p - 1; k++)
	cm[i][j] += am[i][k] * bm[k][j];
    }
  }
}


Void matrixsum(am, bm, cm, n, m)
realtyp (*am)[maxm], (*bm)[maxm], (*cm)[maxm];
short n, m;
{
  /*  cm=am+bm  nxm= (nxm) + (nxm) */
  short i, j;

  for (i = 0; i <= n - 1; i++) {
    for (j = 0; j <= m - 1; j++)
      cm[i][j] = am[i][j] + bm[i][j];
  }
}


Void dotprod(am, bm, n, rout)
realtyp (*am)[maxm], (*bm)[maxm];
short n;
realtyp *rout;
{
  short i;

  *rout = 0.0;
  for (i = 0; i <= n - 1; i++) {
    if (fabs(am[i][0]) < 1e100 && fabs(bm[i][0]) < 1e100)
      *rout += am[i][0] * bm[i][0];
  }
}


Void termprod(am, bm, cm, n, m)
realtyp (*am)[maxm], (*bm)[maxm], (*cm)[maxm];
short n, m;
{
  short i, j;

  /*  cm=am.bm  nxm= (nxm) . (nxm) */
  for (i = 0; i <= n - 1; i++) {
    for (j = 0; j <= m - 1; j++)
      cm[i][j] = am[i][j] * bm[i][j];
  }
}


/* Local variables for gaussj: */
struct LOC_gaussj {
  realtyp (*b)[maxm];
  arM y;
  short ncol;
  boolean *error;

  realtyp w[maxm][maxm];
  short index[maxm][3];
  short nv, irow, icol, n;
  realtyp determ, pivot, t, big;
} ;




Local Void swap_(a, b, LINK)
realtyp *a, *b;
struct LOC_gaussj *LINK;
{
  realtyp hold;

  hold = *a;
  *a = *b;
  *b = hold;
}  /* swap */

/* Local variables for gausj2: */
struct LOC_gausj2 {
  struct LOC_gaussj *LINK;
} ;


Local Void gausj3(LINK)
struct LOC_gausj2 *LINK;
{
  short l, FORLIM;

  /* interchange rows to put pivot on diagonal */
  if (LINK->LINK->irow == LINK->LINK->icol) {
    return;
  }  /* if iroe<>icol */
  LINK->LINK->determ = -LINK->LINK->determ;
  FORLIM = LINK->LINK->n;
  for (l = 0; l <= FORLIM - 1; l++)
    swap_(&LINK->LINK->b[LINK->LINK->irow-1]
	  [l], &LINK->LINK->b[LINK->LINK->icol-1][l], LINK->LINK);
  if (LINK->LINK->nv > 0) {
    FORLIM = LINK->LINK->nv;
    for (l = 0; l <= FORLIM - 1; l++)
      swap_(&LINK->LINK->w[LINK->LINK->irow-1]
	    [l], &LINK->LINK->w[LINK->LINK->icol-1][l], LINK->LINK);
  }
}  /* gausj3 */


Local Void gausj2(LINK)
struct LOC_gaussj *LINK;
{
  struct LOC_gausj2 V;
  short i, j, k, l, l1, FORLIM, FORLIM1, FORLIM2;

  V.LINK = LINK;
  /* actual start of gaussj */
  *LINK->error = false;
  LINK->nv = 1;   /* single constant vector */
  LINK->n = LINK->ncol;
  FORLIM = LINK->n;
  for (i = 0; i <= FORLIM - 1; i++) {
    LINK->w[i][0] = LINK->y[i];   /* copy constant vector */
    LINK->index[i][2] = 0;
  }
  LINK->determ = 1.0;
  FORLIM = LINK->n;
  for (i = 0; i <= FORLIM - 1; i++) {
    /* search for largest element */
    LINK->big = 0.0;
    FORLIM1 = LINK->n;
    for (j = 1; j <= FORLIM1; j++) {
      if (LINK->index[j-1][2] != 1) {
	FORLIM2 = LINK->n;
	for (k = 1; k <= FORLIM2; k++) {
	  if (LINK->index[k-1][2] > 1) {
	    printf("ERROR: matrix is singular\n");
	    *LINK->error = true;
	    goto _L98;   /* abort */
	  }
	  if (LINK->index[k-1][2] < 1) {
	    if (fabs(LINK->b[j-1][k-1]) > LINK->big) {
	      LINK->irow = j;
	      LINK->icol = k;
	      LINK->big = fabs(LINK->b[j-1][k-1]);
	    }
	  }
	}  /* k-loop */
      }
    }  /* j-loop */

    LINK->index[LINK->icol-1][2]++;
    LINK->index[i][0] = LINK->irow;
    LINK->index[i][1] = LINK->icol;

    gausj3(&V);   /* further subdivision of gaussj */
    /* divide pivot row by pivot column */
    LINK->pivot = LINK->b[LINK->icol-1][LINK->icol-1];
    LINK->determ *= LINK->pivot;
    LINK->b[LINK->icol-1][LINK->icol-1] = 1.0;

    FORLIM1 = LINK->n;
    for (l = 0; l <= FORLIM1 - 1; l++)
      LINK->b[LINK->icol-1][l] /= LINK->pivot;
    if (LINK->nv > 0) {
      FORLIM1 = LINK->nv;
      for (l = 0; l <= FORLIM1 - 1; l++)
	LINK->w[LINK->icol-1][l] /= LINK->pivot;
    }

    FORLIM1 = LINK->n;
    /* reduce nonpivot rows */

    for (l1 = 0; l1 <= FORLIM1 - 1; l1++) {
      if (l1 + 1 != LINK->icol) {
	LINK->t = LINK->b[l1][LINK->icol-1];
	LINK->b[l1][LINK->icol-1] = 0.0;
	FORLIM2 = LINK->n;
	for (l = 0; l <= FORLIM2 - 1; l++)
	  LINK->b[l1][l] -= LINK->b[LINK->icol-1][l] * LINK->t;
	if (LINK->nv > 0) {
	  FORLIM2 = LINK->nv;
	  for (l = 0; l <= FORLIM2 - 1; l++)
	    LINK->w[l1][l] -= LINK->w[LINK->icol-1][l] * LINK->t;
	}
      }  /* if l1<>icol */
    }
  }  /* i-loop */
_L98: ;
}  /* gausj2 */


/******* Gauss-jordan*******/
Void gaussj(b_, y_, coef, ncol_, error_)
realtyp (*b_)[maxm];
double *y_, *coef;
short ncol_;
boolean *error_;
{  /* gaus-jordan main program */
  /* square matrix of coefficients */
  /* constant vector */
  /* solution vector */
  /* order of matrix */
  /* true if matrix singular */

  /* Gauss Jordan matrix inversion and solution */

  /* B(n,n) coefficient matrix becomes inverse */
  /* Y(n) original constant vector */
  /* W(n,m) constant vector(s) become solution vector */
  /* DETERM is the determinant */
  /* ERROR=1 if singular */
  /* INDEX(n,3) */
  /* NV is number of constant vectors */
  struct LOC_gaussj V;
  short i, k, l, FORLIM, FORLIM1;

  V.b = b_;
  memcpy(V.y, y_, sizeof(arM));
  V.ncol = ncol_;
  V.error = error_;
  gausj2(&V);   /* first half of gaussj */
  if (*V.error)
    goto _L99;
  FORLIM = V.n;
  /* interchange columns */
  for (i = 1; i <= FORLIM; i++) {
    l = V.n - i + 1;
    if (V.index[l-1][0] != V.index[l-1][1]) {
      V.irow = V.index[l-1][0];
      V.icol = V.index[l-1][1];
      FORLIM1 = V.n;
      for (k = 0; k <= FORLIM1 - 1; k++)
	swap_(&V.b[k][V.irow-1], &V.b[k][V.icol-1], &V);
    }  /* if index */
  }  /* i-loop */
  FORLIM = V.n;
  for (k = 0; k <= FORLIM - 1; k++) {
    if (V.index[k][2] != 1) {
      printf("\007ERROR: matrix is singular\n");
      *V.error = true;
      goto _L99;   /* abort */
    }
  }
  FORLIM = V.n;
  for (i = 0; i <= FORLIM - 1; i++)
    coef[i] = V.w[i][0];
_L99: ;
}  /* gaussj */





/* End. */
